%global debug_package %{nil}
%define rpm_build_dir_name ${RPM_BUILD_DIR}/${RPM_PACKAGE_NAME}-${RPM_PACKAGE_VERSION}

%define com_git_url %{xos_com_git_url}
%define com_git_tag %{xos_com_git_tag}
%define bmcdrv_path %{rpm_build_dir_name}/FJSVxosbmc/driver
%define tool_src_path %{rpm_build_dir_name}/FJSVxosbmc/tool/src
%define tool_script_path %{rpm_build_dir_name}/FJSVxosbmc/tool/script
%define tool_system_path %{rpm_build_dir_name}/FJSVxosbmc/tool/system
%define etc_dir /opt/FJSVxos/bmc/etc
%define bin_dir /opt/FJSVxos/bmc/bin
%define sys_dir /etc/systemd/system
%define modules_dir /lib/modules

%define tmp_modules_list    /var/run/rpm-kmod-%{name}-modules

Name:FJSVxosbmc
Version:%{pkg_version}
Release:        %{pkg_revision}%{?dist}
Summary:bmc driver
Group:System Environment/Kernel
License:GPLv2
#URL:
#Sourceタグが定義されていないとsrpmが作れない
Source:%{name}-%{version}.tar.gz 

#BuildRoot:     %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
#BuildRequires:
#Requires:
#Patch01:hoge.patch

%description
This package provides bmc relevant drivers.
Version coexistence: possible
Previous version: 0.0.7-1 and over
Same version range: node
After updating: reboot
Relation package: none

%prep
rm -rf %{rpm_build_dir_name}
rm -rf ${RPM_BUILD_ROOT}
rm -rf ${RPM_BUILD_DIR}/%{name}-%{version}

# Donwload
pushd ${RPM_SOURCE_DIR}
git archive --format=tar.gz --prefix %{name}-%{version}/ --output %{name}-%{version}.tar.gz --remote %{com_git_url} %{com_git_tag}
popd

tar xvzf ${RPM_SOURCE_DIR}/%{name}-%{version}.tar.gz -C ${RPM_BUILD_DIR}

#after extracts tar.gz, move to %{name}-%{version} dir
#%setup

%build
#driver module compile
#now, current dir is %{name}-%{version}
pushd %{bmcdrv_path}
ARCH=arm64 CROSS_COMPILE=%{xos_cross_compile} KDIR=%{xos_krn_dir} \
	make -C %{xos_krn_dir} M=`pwd` modules
popd

#tool
pushd %{tool_src_path}
CROSS_COMPILE=%{xos_cross_compile} make
popd

%install
rm -rf %{buildroot}/

EXTRA_DIR=%{modules_dir}/%{xos_krn_ver}/extra/bmc

#bmc driver install
pushd %{bmcdrv_path}
mkdir -p %{buildroot}/$EXTRA_DIR
install -p -m 644 bmc_drv.ko %{buildroot}/$EXTRA_DIR
popd

#tool install
mkdir -p %{buildroot}/%{bin_dir}
install -p -m 500 %{tool_src_path}/bmcreport %{buildroot}/%{bin_dir}

#startup install
mkdir -p %{buildroot}/%{etc_dir}
install -p -m 755 %{tool_script_path}/FJSVxosbmc %{buildroot}/%{etc_dir}

#service install
mkdir -p %{buildroot}/%{sys_dir}
install -p -m 644 %{tool_system_path}/FJSVxosbmc.service %{buildroot}/%{sys_dir}

%clean
rm -rf %{buildroot}

%pre
if [ "$1" = "2" ]
then
	#perform when upgrade(rpm -U).
	systemctl disable FJSVxosbmc
fi

%post
if [ -e "/boot/System.map-%{xos_krn_ver}" ]
then
	depmod -aeF "/boot/System.map-%{xos_krn_ver}" "%{xos_krn_ver}" > /dev/null || :
fi

if [ -x "/sbin/weak-modules" ]
then
	rpm -ql %{name}-%{version} | grep '\.ko$' | /sbin/weak-modules --add-modules --no-initramfs
fi
systemctl enable FJSVxosbmc

%preun
if [ "$1" = "0" ]
then
	#perform when elase(rpm -e) only.
	systemctl disable FJSVxosbmc
fi

rpm -ql %{name}-%{version} | grep '\.ko$' > %{tmp_modules_list}

%postun
if [ -e "/boot/System.map-%{xos_krn_ver}" ]
then
    depmod -aeF "/boot/System.map-%{xos_krn_ver}" "%{xos_krn_ver}" > /dev/null || :
fi

modules=( $(cat %{tmp_modules_list}) )
rm %{tmp_modules_list}
if [ -x "/sbin/weak-modules" ]
then
    printf '%s\n' "${modules[@]}" | /sbin/weak-modules --remove-modules --no-initramfs
fi

%files

%defattr(644,root,root,-)
%{modules_dir}/*/extra/bmc/bmc_drv.ko
%{sys_dir}/FJSVxosbmc.service
%defattr(500,root,root,-)
%{bin_dir}/bmcreport
%defattr(755,root,root,-)
%{etc_dir}/FJSVxosbmc

%changelog
